#include <iostream>
#include <fstream>
#include "Cinterface.h"
#include <string>
#include <iomanip>//used for setting number of decimals in posterior
#include <cstdlib>
#include <zlib.h>
#include <sstream>
#include <cstring>
#include <vector>
#include <sys/stat.h>
#ifndef _types_h
#define _types_h
#include "types.h"
#endif
#include <pthread.h>
#include <assert.h>

#ifndef _alloc_h
#define _alloc_h
#include "alloc.h"
#endif





#include "filereader_and_conversions.h"
#include "extractors.h"
#include "asort.h"
#include "relateAdmix.h"
using namespace std;

pthread_t *threads = NULL;
pthread_t *threads1 = NULL;
pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;
int NumJobs;
int jobs;


eachPars *allPars = NULL;

void *relateWrap(void *a){
  eachPars *p = (eachPars *)a;
  myPars *pars=p->pars;
  int i=p->ind1;
  int j=p->ind2;
  int numIt=0;
  /*
  fprintf(stderr,"%f\n",pars->tolStop);
  fprintf(stderr,"%f\n",pars->tol);
  fprintf(stderr,"%d\n",pars->nSites);
  fprintf(stderr,"%d\n",i);
  fprintf(stderr,"%d\n",j);
  fprintf(stderr,"%d\n",pars->K);
  fprintf(stderr,"%d\n",pars->nIter);
  fprintf(stderr,"%d\n",pars->useSq);
  fprintf(stderr,"%d\n",pars->data->matrix[i][0]);
 fprintf(stderr,"%d\n",pars->data->matrix[j][0]);
 fprintf(stderr,"%f\n",pars->Q[j][0]);
fprintf(stderr,"%f\n",p->start[0]);
  */
  relateAdmix(pars->tolStop,pars->nSites,pars->K,pars->nIter,pars->useSq,numIt,pars->data->matrix[i],pars->data->matrix[j],pars->Q[i],pars->Q[j],p->start,pars->F,pars->tol);
  p->numIter=numIt;
}

void readDoubleGZ(double **d,int x,int y,const char*fname,int neg){
  fprintf(stderr,"opening : %s with x=%d y=%d\n",fname,x,y);
  const char*delims=" \n";
  gzFile fp = NULL;
  if((fp=gzopen(fname,"r"))==NULL){
    fprintf(stderr,"cant open:%s\n",fname);
    exit(0);
  }
  int lens=1000000 ;
  char buf[lens];
  for(int i=0;i<x;i++){
    if(NULL==gzgets(fp,buf,lens)){
 	fprintf(stderr,"Error: Only %d sites in frequency file\n",i);
	exit(0);
    }
    if(neg)
      d[i][0] = 1-atof(strtok(buf,delims));
    else
      d[i][0] = atof(strtok(buf,delims));
    for(int j=1;j<y;j++){
      //      fprintf(stderr,"i=%d j=%d\n",i,j);
      if(neg)
	d[i][j] = 1-atof(strtok(NULL,delims));
      else
	d[i][j] = atof(strtok(NULL,delims));
    }
  }
  if(NULL!=gzgets(fp,buf,lens)){
    fprintf(stderr,"Error: Too many sites in frequency file. Only %d sites in plink file\n",x);
    exit(0);

  }
  gzclose(fp);
}

void readDouble(double **d,int x,int y,const char*fname,int neg){
  fprintf(stderr,"opening : %s with x=%d y=%d\n",fname,x,y);
  const char*delims=" \n";
  FILE *fp = NULL;
  if((fp=fopen(fname,"r"))==NULL){
    fprintf(stderr,"can't open:%s\n",fname);
    exit(0);
  }
  int lens=1000000 ;
  char buf[lens];
  for(int i=0;i<x;i++){
    if(NULL==fgets(buf,lens,fp)){
    	fprintf(stderr,"Error: Only %d individuals in admxiture (-qname) file\n",i);
      exit(0);
    }
    if(neg)
      d[i][0] = 1-atof(strtok(buf,delims));
    else
      d[i][0] = atof(strtok(buf,delims));
    for(int j=1;j<y;j++){
      //      fprintf(stderr,"i=%d j=%d\n",i,j);
      if(neg)
	d[i][j] = 1-atof(strtok(NULL,delims));
      else
	d[i][j] = atof(strtok(NULL,delims));
    }
  }
   if(NULL!=fgets(buf,lens,fp)){
    fprintf(stderr,"Error: Too many individuals in admixture (-qname) file. Only %d individuals in plink file\n",x);
    exit(0);
  }

  fclose(fp); 
}

int getK(const char*fname){
  const char*delims=" \n";
  FILE *fp = NULL;
  if((fp=fopen(fname,"r"))==NULL){
    fprintf(stderr,"can't open:%s\n",fname);
    exit(0);
  }
  int lens=100000 ;
  char buf[lens];
  if(NULL==fgets(buf,lens,fp)){
    fprintf(stderr,"Increase buffer\n");
    exit(0);
  }
  strtok(buf,delims);
  int K=1;
  while(strtok(NULL,delims))
    K++;
  fclose(fp);

  return(K);
}


double **allocDouble(size_t x,size_t y){
  double **ret= new double*[x];
  for(size_t i=0;i<x;i++)
    ret[i] = new double[y];
  return ret;
}


void info(){
  fprintf(stderr,"Arguments:\n");
  fprintf(stderr,"\t-plink name of the binary plink file (excluding the .bed)\n");
  fprintf(stderr,"\t-fname Ancestral population frequencies\n"); 
  fprintf(stderr,"\t-qname Admixture proportions\n"); 
  fprintf(stderr,"\t-o name of the output file\n"); 

  fprintf(stderr,"Setup:\n"); 
  fprintf(stderr,"\t-P Number of threads\n"); 
  // fprintf(stderr,"\t-method If 0 no acceleration of EM algorithm\n"); 
  //  fprintf(stderr,"\t-misTol Tolerance for considering site as missing\n");

  //  fprintf(stderr,"Stop chriteria:\n"); 
  //  fprintf(stderr,"\t-tol Tolerance for convergence\n"); 
  //  fprintf(stderr,"\t-maxiter Maximum number of EM iterations\n"); 


  //  fprintf(stderr,"Filtering\n"); 
  //fprintf(stderr,"\t-minMaf Minimum minor allele frequency\n"); 
  //fprintf(stderr,"\t-minLrt Minimum likelihood ratio value for maf>0\n"); 
  //fprintf(stderr,"\t-minInd Minumum number of informative individuals\n");


  exit(0);

}

void *functionC(void *a)
{
  int running_job;

  pthread_mutex_lock(&mutex1);
  //  int c=-1;
  while (jobs > 0) {
    running_job = jobs--;
    //     printf(" >>> Job starting: %d\n", c);
    //  c++;
    pthread_mutex_unlock(&mutex1);

    
    int c = NumJobs-running_job;
    ///////////////////////////////
    // eachPars *p = (eachPars *)a;
    ///////////////////////////////

    eachPars p=allPars[c];
    myPars *pars=p.pars;
    int i=p.ind1;
    int j=p.ind2;
    int numIt=0;
    relateAdmix(pars->tolStop,pars->nSites,pars->K,pars->nIter,pars->useSq,numIt,pars->data->matrix[i],pars->data->matrix[j],pars->Q[i],pars->Q[j],p.start,pars->F,pars->tol);
    p.numIter=numIt;
    p.numI[0]=numIt;
    //pars->nIter=numIt;

   

    //////////////////////////////////////////////

    pthread_mutex_lock(&mutex1);

    int d = NumJobs-running_job;
    if(d%50==0)
      fprintf(stderr,"\rrunning i1:%d i2:%d",allPars[d].ind1,allPars[d].ind2);  
    //    printf(" >>> Job done: %d\n", NumJobs-running_job);
  }
  pthread_mutex_unlock(&mutex1);

  return NULL;
}



int main(int argc, char *argv[]){
 clock_t t=clock();//how long time does the run take
  time_t t2=time(NULL);


  for(int i=0;i<argc;i++)
    printf("%s ",argv[i]);
  printf("\n");

  if(argc==1){
    info();
    return 0;
  }

 const char *outname = "output.k";
  int autosomeMax = 23;
  string geno= "";
  string pos = "";
  string chr = "";
  string plink_fam;
  string plink_bim;
  string plink_bed;
  int nThreads =1;
  bArray *plinkKeep = NULL; //added in 0.97;
  const char* fname = NULL;
  const char* qname = NULL;



  int argPos=1;

  while(argPos <argc){
    if (strcmp(argv[argPos],"-o")==0){
      outname  = argv[argPos+1]; 
    }
    else if (strcmp(argv[argPos],"-a")==0){
      autosomeMax = atoi(argv[argPos+1])+1; 
    }
    else if(strcmp(argv[argPos],"-fname")==0 || strcmp(argv[argPos],"-f")==0) 
      fname=argv[argPos+1]; 
    else if(strcmp(argv[argPos],"-qname")==0 || strcmp(argv[argPos],"-q")==0) 
      qname=argv[argPos+1];
   else if(strcmp(argv[argPos],"-nThreads")==0 || strcmp(argv[argPos],"-P")==0) 
     nThreads=atoi(argv[argPos+1]);
    else if(strcmp(argv[argPos],"-plink")==0){
      std::string p_str =string( argv[argPos+1]);
      if(p_str.length()>4){
	std::string ext = p_str.substr(p_str.length()-4,p_str.length());
	if (!ext.compare(".bed")||!ext.compare(".bim")||!ext.compare(".fam")){
	  std::string front = p_str.substr(0,p_str.length()-4);
	  plink_bim = (front+".bim");
	  plink_fam = (front+".fam");
	  plink_bed = (front+".bed");
	}else{
	  plink_bim = (p_str+".bim");
	  plink_fam = (p_str+".fam");
	  plink_bed = (p_str+".bed");	
	}}else{
	plink_bim = (p_str+".bim");
	plink_fam = (p_str+".fam");
	plink_bed = (p_str+".bed");	
     	}
    }
    else{
      printf("\nArgument unknown will exit: %s \n",argv[argPos]);
      info();
      return 0;
    }
    
    argPos+=2;
  }
  

  //read plink
  printf("\t-> Will assume these are the plink files:\n\t\tbed: %s\n\t\tbim: %s\n\t\tfam: %s\n",plink_bed.c_str(),plink_bim.c_str(),plink_fam.c_str());
  int numInds = numberOfLines(plink_fam.c_str())-1;//the number of individuals is just the number of lines

  myPars *pars =  new myPars();
  plinkKeep = doBimFile(pars,plink_bim.c_str()," \t",autosomeMax);  
  printf("\t-> Plink file contains %d autosomale SNPs\n",plinkKeep->numTrue);
  iMatrix *tmp = bed_to_iMatrix(plink_bed.c_str(),numInds,plinkKeep->x);
  if(tmp->x==plinkKeep->numTrue)
      pars->data = tmp;
    else{
      pars->data = extractOK(plinkKeep,tmp);
      killMatrix(tmp);
    }
    killArray(plinkKeep);
    mysort(pars,0);

    // printf("Dimension of genodata:=(%d,%d), positions:=%d, chromosomes:=%d\n",pars->data->x,pars->data->y,pars->position->x,pars->chr->x);
  if(pars->data->y != pars->chr->x || pars->position->x != pars->data->y){
    printf("Dimension of data input doesn't have compatible dimensions, program will exit\n");
    printf("Dimension of genodata:=(%d,%d), positions:=%d, chromosomes:=%d\n",pars->data->x,pars->data->y,pars->position->x,pars->chr->x);
    return 0;
  }








  int K=getK(qname);
  
  int nSites=pars->data->y;
  int nInd=pars->data->x;
  fprintf(stderr,"\t\t->K=%d\tnSites=%d\tnInd=%d\n",K,nSites,nInd);

  FILE *fp=fopen(outname,"w");
  double **F =allocDouble(nSites,K);
  double **Q =allocDouble(nInd,K);
  pars->F=F;
  pars->Q=Q;
  readDouble(Q,nInd,K,qname,0);
  readDoubleGZ(F,nSites,K,fname,1);
  double tolStop=0.000001;
  int nIter=500;
  int useSq=1;
  int numIter=400;
  double tol=0.0001;
  




fprintf(fp,"ind1\tind2\tk0\tk1\tk2\tnIter\n");

  //fun begins
 if(nThreads==1){// no threads
    double *start=new double[3];
    
    fprintf(stderr,"running i1:0 i2:0");  
    for(int i=1;i<nInd-1;i++){
      for(int j=i+1;j<nInd;j++){
	start[0]=0.7;
	start[1]=0.2;
	start[2]=0.1;
	fprintf(stderr,"\rrunning i1:%d i2:%d",i,j);  
	relateAdmix(tolStop,nSites,K,nIter,useSq,numIter,pars->data->matrix[i],pars->data->matrix[j],pars->Q[i],pars->Q[j],start,pars->F,tol);
	fprintf(fp,"%d\t%d\t%f\t%f\t%f\tnIter=%d\n",i,j,start[0],start[1],start[2],numIter);
      }
    }
    delete[] start;
  }
 else if(0){ // with threads
    int totNum = nInd*(nInd-1)/2;
    int nLoop=(int)(totNum/nThreads);
    if(totNum%nThreads)
      nLoop++;


    //    fprintf(stderr,"totNum %d\tnLoop %d\n",totNum,nLoop);
    allPars = new eachPars[nThreads];
    pars->nIter=nIter;
    pars->tol=tol;
    pars->tolStop=tolStop;
    pars->K=K;
    pars->nSites=nSites;
    pars->useSq=useSq;
    int *indMatrix = new int[nInd*(nInd-1)];
    int counter=0;
    for(int i=0;i<nInd-1;i++){
      for(int j=i+1;j<nInd;j++){
	indMatrix[counter*2]=i;
	indMatrix[counter*2+1]=j;
	counter++;
      }
    }
    pthread_t threads[nThreads];

    int count=0;
    int rc;
    for(int nl=0;nl<nLoop;nl++){
      for(int c=0;c<nThreads;c++){//prep
	if(count+c>=totNum)
	  break;

	//	fprintf(stdout,"count %d, c %d, totNum %d\n",count,c,totNum);
	double *start=new double[3];
	start[0]=0.7;
	start[1]=0.2;
	start[2]=0.1;
	int i=indMatrix[(count+c)*2];
	int j=indMatrix[(count+c)*2+1];

	eachPars *temp = new eachPars;
	allPars[c].start=start;
	allPars[c].ind1=i;
	allPars[c].ind2=j;
	allPars[c].numIter=0;
	allPars[c].pars=pars;
	//fprintf(stderr,"\rrunning i1:%d i2:%d",i,j);
	fprintf(stderr,"\rrunning i1:%d i2:%d",i,j);  

      }
      for(int c=0;c<nThreads;c++){//run
	if(count+c>=totNum)
	  break;
	rc = pthread_create(&threads[c], NULL, relateWrap, &allPars[c]);
	assert(0 == rc);
      }


      for(int c=0;c<nThreads;c++){//join
	if(count+c>=totNum)
	  break;
 	rc = pthread_join(threads[c], NULL);
	assert(0 == rc);
     }


      for(int c=0;c<nThreads;c++){//print
	if(count+c>=totNum)
	  break;
	fprintf(fp,"%d\t%d\t%f\t%f\t%f\t%d\n",allPars[c].ind1,allPars[c].ind2,allPars[c].start[0],allPars[c].start[1],allPars[c].start[2],allPars[c].numIter);
      }

      count+=nThreads;
 
    }
    delete[] indMatrix;
  }
else{ // with threads


  NumJobs = nInd*(nInd-1)/2;
  jobs =  nInd*(nInd-1)/2;
  allPars = new eachPars[NumJobs];
  pars->nIter=nIter;
  pars->tol=tol;
  pars->tolStop=tolStop;
  pars->K=K;
  pars->nSites=nSites;
  pars->useSq=useSq;
  int *indMatrix = new int[nInd*(nInd-1)];
  int counter=0;
  for(int i=0;i<nInd-1;i++){
    for(int j=i+1;j<nInd;j++){
      indMatrix[counter*2]=i;
      indMatrix[counter*2+1]=j;
      counter++;
    }
  }
  for(int c=0;c<NumJobs;c++){
   double *start=new double[3];
   int *numI=new int[1];
    start[0]=0.7;
    start[1]=0.2;
    start[2]=0.1;
    int i=indMatrix[c*2];
    int j=indMatrix[c*2+1];

    allPars[c].start=start;
    allPars[c].ind1=i;
    allPars[c].ind2=j;
    allPars[c].numIter=0;
    allPars[c].numI=numI;
    allPars[c].pars=pars;

  }
  pthread_t thread1[nThreads];

  for (int i = 0; i < nThreads; i++)
    pthread_create(&thread1[i], NULL, &functionC, NULL);

  // Wait all threads to finish
  for (int i = 0; i < nThreads; i++)
    pthread_join(thread1[i], NULL);

  for (int c = 0; c < NumJobs; c++)
    fprintf(fp,"%d\t%d\t%f\t%f\t%f\t%d\n",allPars[c].ind1,allPars[c].ind2,allPars[c].start[0],allPars[c].start[1],allPars[c].start[2],allPars[c].numI[0]);
  

  delete[] indMatrix;
 }

  fprintf(stderr,"\n");
for(int j = 0; j < nSites; j++) 
    delete[] F[j];
  delete[] F;
  
  for(int i = 0; i < nInd; i++)
    delete [] Q[i];
  delete[] Q;

  fclose(fp);
  delete[] allPars;


  fprintf(stderr, "\t[ALL done] cpu-time used =  %.2f sec\n", (float)(clock() - t) / CLOCKS_PER_SEC);
  fprintf(stderr, "\t[ALL done] walltime used =  %.2f sec\n", (float)(time(NULL) - t2));  
  fprintf(stderr, "\t[ALL done] results have been outputted to %s\n",outname);



  return(0);
}

